<template>
  <div class="app-container">
    <el-row type="flex" justify="space-between" ref="listQueryContainer" class="query-container">
      <el-col>
        <el-form :inline="true" style="flex-wrap: wrap" :model="listQuery" ref="listQuery" @submit.native.prevent @keyup.enter.native="onSubmit">
          <el-form-item label="物品分类" prop="classifyId">
            <el-select v-model="listQuery.classifyId" placeholder="请选择物品分类" clearable @change="onFilterChange">
              <el-option v-for="item in classifyList" :key="item.id" :label="item.name" :value="item.id"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="物品名称" prop="name">
            <el-input v-model.trim="listQuery.name" maxlength="16" placeholder="请输入物品名称" clearable @clear="listQuery.name=undefined" @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="添加时间范围" prop="dateRange">
            <el-date-picker
                v-model="listQuery.dateRange"
                value-format="yyyy-MM-dd HH:mm:ss"
                type="daterange"
                range-separator="-"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
                :default-time="['00:00:00', '23:59:59']"
                @change="onFilterChange">
            </el-date-picker>
          </el-form-item>
          <el-form-item label-width="0">
            <el-button @click="onFilterChange" type="primary">查询</el-button>
            <el-button @click="resetFields" plain type="primary">重置</el-button>
            <el-button @click="onExport" plain type="primary">导出</el-button>
            <el-button @click="onSave" type="primary">入库</el-button>
          </el-form-item>
        </el-form>
      </el-col>
      <form-clear :shrinkable="shrinkable" @clear="resetFields" @change="onExpansion"/>
    </el-row>
    <el-table :data="list" border stripe highlight-current-row ref="table" class="mt10" @sort-change="onSortChange" @row-click="onRowClick">
      <el-table-column type="index" :index="indexCompute" label="序号" align="center" fixed="left" width="60px"/>
      <el-table-column prop="name" label="物品名称" sortable="custom" align="center" fixed="left" min-width="160px"/>
      <el-table-column prop="count" label="物品数量" sortable="custom" align="center" width="110px"/>
      <el-table-column prop="classifyId" label="物品分类" sortable="custom" align="center" min-width="160px">
         <template v-slot="scope">
          {{ classifyList.length > 0 && classifyList.find(item => item.id === scope.row.classifyId).name }}
        </template>
      </el-table-column>
      <el-table-column prop="description" label="物品介绍" sortable="custom" align="center" min-width="200px"/>
      <el-table-column prop="createTime" label="物品添加时间" sortable="custom" align="center" min-width="160px">
         <template v-slot="scope">{{ scope.row.createTime | dateFormat }}</template>
      </el-table-column>
      <el-table-column prop="updateTime" label="物品更新时间" sortable="custom" align="center" min-width="160px">
         <template v-slot="scope">{{ scope.row.updateTime | dateFormat }}</template>
      </el-table-column>
      <el-table-column label="操作" align="center" fixed="right" min-width="90px">
         <template v-slot="scope">
          <el-link type="primary" icon="el-icon-sold-out" @click="onTake(scope.row)">出库</el-link>
        </template>
      </el-table-column>
    </el-table>
    <pagination :total="total" :page.sync="listQuery.page" :size.sync="listQuery.size" @change="onPageChange"/>

    <dialog-take v-if="takeDialogVisible" :visible.sync="takeDialogVisible" :data="selectItem" @update="onFilterChange"></dialog-take>
    <dialog-add v-if="saveDialogVisible" :visible.sync="saveDialogVisible" @add="onFilterChange"></dialog-add>

    <el-dialog title="导出" :visible.sync="exportVisible" :close-on-click-modal="false" :close-on-press-escape="false" width="600px">
      <el-progress :text-inside="true" :stroke-width="24" :percentage="exportProgress" status="success"></el-progress>
      <el-button slot="footer" @click="onCancelExport">取 消</el-button>
    </el-dialog>
  </div>
</template>

<script>
import DialogAdd from "./dialogAdd";
import DialogTake from "./dialogTake";

export default {
  name: "assetsGoods",
  components: {DialogAdd,DialogTake},

  data() {
    return {
      shrinkable: false, // 查询条件是否可以展开
      listQuery: { // 查询对象
        classifyId: undefined, // 物品分类
        name: undefined, // 物品名称
        dateRange: [], // 时间范围
        startTime: undefined,
        endTime: undefined,
        order: undefined,
        page: 1,
        size: 10
      },

      list: [], // 结果列表
      total: 0, // 总结果数量

      classifyList: [], // 物品分类列表

      exportVisible: false, // 是否显示导出对话框
      exportData: [], // 导出数据
      exportPagination: { // 导出分页
        page: 1,
        size: 500,
      },
      exportProgress: 0, // 导出进度
      exportCancel: false, // 是否取消导出

      takeDialogVisible: false, // 出库对话框是否可见
      saveDialogVisible: false, // 入库对话框是否可见

      selectItem: undefined, // 选中的单条记录
    }
  },

  watch: {
    // 监听日期范围变化
    'listQuery.dateRange'(value) {
      if (value) {
        this.listQuery.startTime = value[0];
        this.listQuery.endTime = value[1];
      } else {
        this.listQuery.startTime = undefined;
        this.listQuery.endTime = undefined;
      }
    }
  },

  // 页面创建
  created() {
    this.initData();
  },

  // 页面挂载
  mounted() {
    this.initQuery();
    this.getList();
    this.initView();
  },

  // keep-alive 显示界面时调用
  activated() {
    this.$refs["table"].doLayout();
  },

  // keep-alive 页面隐藏
  deactivated() {
  },

  methods: {
    // 初始化数据
    initData() {
      this.$axios.get("/v1/stock/classify/list", {params: {page: 1, size: 999}}, false).then(data => {
        this.classifyList = data.list;
      });
    },

    // 初始化查询条件
    initQuery() {
      if (this.$store.state.app.paramCache) {
        let query = this.$storage.getData(this.$options.name);
        if (Object.keys(query).length > 0) {
          this.listQuery = query;
          if (query.order) {
            this.$refs.table.sort(query.order, query.order === "asc" ? "ascending" : "descending");
          } else {
            this.$refs.table.clearSort();
          }
        }
      }
    },

    // 初始化视图
    initView() {
      this.$nextTick(() => {
        this.shrinkable = this.$store.state.app.filterShrink && this.$refs['listQuery'].$el.offsetHeight > 51;
      })
    },

    // 展开/收起查询条件
    onExpansion(show) {
      this.$refs['listQueryContainer'].$el.style.height = show ? "auto" : "51px";
    },

    // 表格索引
    indexCompute(index) {
      return index + 1 + (this.listQuery.page - 1) * this.listQuery.size;
    },

    // 表单提交
    onSubmit() {
      this.onFilterChange();
    },

    // 表单清除
    resetFields() {
      this.$refs['listQuery'].resetFields();
      this.listQuery.order = undefined;
      this.$refs.table.clearSort();
      this.onFilterChange();
    },

    // 排序改变
    onSortChange({prop, order}) {
      if (order === "ascending") {
        this.listQuery.order = "+" + prop;
      } else if (order === "descending") {
        this.listQuery.order = "-" + prop;
      } else {
        this.listQuery.order = undefined;
      }
      this.onFilterChange();
    },

    // 行点击
    onRowClick(row, column, event) {
      this.$refs["table"].setCurrentRow(row);
    },

    // 入库
    onSave() {
      this.saveDialogVisible = true;
    },

    // 出库
    onTake(item) {
      this.selectItem = item;
      this.takeDialogVisible = true;
    },

    // 条件改变
    onFilterChange() {
      this.listQuery.page = 1;
      this.$nextTick(this.getList);
    },

    // 页码改变
    onPageChange() {
      this.getList();
    },

    // 加载列表
    getList() {
      // 缓存参数
      if (this.$store.state.app.paramCache) {
        this.$storage.setData(this.$options.name, this.listQuery);
      }

      this.$axios.get("/v1/stock/goods/list", {params: this.listQuery}).then(data => {
        this.list = data.list;
        this.total = data.total;
      });
    },

    // 导出数据
    onExport() {
      if (this.total > 0) {
        this.exportPagination.page = 1;
        this.exportData = [];
        this.exportVisible = true;
        this.getExportData();
      }
    },

    // 取消导出
    onCancelExport() {
      this.exportVisible = false;
      this.exportCancel = true;
    },

    // 获取数据并导出
    getExportData() {
      if (!this.exportCancel) {
        this.$axios.get("/v1/stock/goods/list", {params: {...this.listQuery, ...this.exportPagination}}).then(data => {
          this.exportPagination.page++;
          this.exportData = this.exportData.concat(data.list);
          this.exportProgress = Math.round(this.exportData.length * 100 / this.total);
          if (this.exportData.length < this.total && data.list.length > 0) {
            this.getExportData();
          } else {
            this.exportVisible = false;

            let tHeader = ["序号",
              "物品名称",
              "物品数量",
              "物品分类",
              "物品介绍",
              "物品添加时间",
              "物品更新时间"
            ];
            let filterVal = ["index",
              "name",
              "count",
              "classifyId",
              "description",
              "createTime",
              "updateTime"
            ];
            let data = this.exportData.map((value, index) => filterVal.map((key) => {
              if (key === "index") {
                return index + 1;
              } else if (key === "classifyId") {
                return this.classifyList.find(item => item.id === value[key]).name;
              } else {
                return value[key];
              }
            }));
            import('@/utils/Export2Excel').then(excel => {
              excel.export_json_to_excel({
                header: tHeader, // 表头 必填
                data, // 具体数据 必填
                filename: '物品库存列表', // 非必填
                autoWidth: true, // 非必填
                bookType: 'xlsx' // 非必填
              })
            })
          }
        });
      }
    }
  }
}
</script>

<style scoped lang="scss">
.app-container {

}
</style>
